/*
 * Simple VGA test for Pano Logic
 * Copyright (c) 2018 Miguel Angel Rodriguez Jodar.
 * 
 * This program is free software: you can redistribute it and/or modify  
 * it under the terms of the GNU General Public License as published by  
 * the Free Software Foundation, version 3.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

`timescale 1ns / 1ps
`default_nettype none

module panotest2fantasma (
  input wire osc_clk,  // reloj de 50 MHz de la Terasic DE2
  output wire vo_clk,
  output wire [9:0] vo_r,
  output wire [9:0] vo_g,
  output wire [9:0] vo_b,
  output wire vo_hsync,
  output wire vo_vsync,
  output wire vo_blank_
  ); 
  
  assign vo_blank_ = 1'b1;  // el blanking lo gestionaremos desde el propio generador de video

  // Metodo chusquero para generar una se�al de reloj de 25 MHz a partir del reloj de 50 MHz
  // y adem�s sacarlo por un pin externo para el DAC de video
  //osc_clk es 50mhz , clk1 es 25mhz.
  reg clk1;
  wire clkvideo;
	always@(posedge osc_clk)
	clk1<=~clk1;
   assign vo_clk = clk1;
   assign clkvideo = clk1;
 
  fantasma_rebotando efecto_molon (
    .clk(clkvideo),
    .r(vo_r),
    .g(vo_g),
    .b(vo_b),
    .hsync(vo_hsync),
    .vsync(vo_vsync)
  );
endmodule
